
#include <stdio.h>
#include <stdarg.h>


void DAbt_Handler(void)
{
}
void FIQ_Handler(void)
{
}
void IRQ_Handler(void)
{
}
void PAbt_Handler(void)
{
}
void Undef_Handler(void)
{
}
void SWI_Handler(void)
{
}

__inline char	LCD_PrintfPS(int *nd, char * strout, const char *strin)
{
	char	sym;
	int		cnt = 0;
	while(1)
	{
		sym = *strin++;
		switch(sym)
		{
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case '.':
			case '-':
				*strout++ = sym;
				cnt++;
				break;
			case '\n':
			case '\r':
			case ' ':
			case 0:
				*nd = ++cnt;
				return sym;
			default:
				*strout++ = sym;
				*nd = ++cnt;
				return sym;
		}
	}
}
int LCD_Printf(const char* fmt, ...)
{
	int		cnt = 0;
	int	 adrplus;
	char	sym;
	char	stype[8];
	va_list	arp;
	char str[128] = {0};
	va_start(arp, fmt);
	while(1)
	{
		sym = *fmt++;
		if(sym == '%')
		{
			memset(&stype[0], 0, 8);
			stype[0] = sym;
			sym = LCD_PrintfPS(&adrplus, &stype[1], fmt);
			fmt += adrplus;
			switch(sym)
			{
				case 's':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, char *));
					continue;
				case 'c':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, int));
					continue;
				case 'i':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, int));
					continue;
				case 'd':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, int));
					continue;
				case 'u':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, unsigned int));
					continue;
				case 'x':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, unsigned int));
					continue;
				case 'X':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, unsigned int));
					continue;
				case 'f':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, float));
					continue;
				case 'F':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, float));
					continue;
				case 'e':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, float));
					continue;
				case 'E':
					cnt += sprintf(&str[cnt],&stype[0],va_arg(arp, float));
					continue;
				default:
					break;
			}
		}
		else if(!(sym))
			goto m1;
		else
			str[cnt++] = sym;
	}
m1:
	va_end(arp);
	return cnt;
}


int main(void)
{
		LCD_Printf("string:%s char:%c ", "testing", '2');
		LCD_Printf("int: %i %d", 1234, -4678);
		LCD_Printf("unsigned int: %u %u", 1234, 4678);
		LCD_Printf("hex: %x %X", 1234, 123);
		LCD_Printf("float:%.2f %f ", 3.1459, 3.1459);
		LCD_Printf("float:%.e %E ", 3.1459, 3.1459);
		while(1);
	return 0;
}
